' Source File : FBF2HTM.Bas
' Object File : FBF2HTM.Exe
' Start Date  : 03/08/2013
' Author      : Ben Ritchey
' Description : Build HTML listing for Web from OS/2 Files.BBS
'               with multi-line descriptions possible.
'               Copyright {c} 2015 by Ben Ritchey

#COMPILER PBCC 5
#COMPILE EXE
#DIM ALL

FUNCTION PBMAIN()

LOCAL A, C, D, F, S, Z, DREC, DTE, DRCOMMA1, DRCOMMA2, DRCOMMA3 AS STRING
LOCAL AC, FBTITLE, FBDNAME, FLNAME, FLNME AS STRING
LOCAL L, AA, AB, EL, FF, FL, CA, CL, LC, NI, SL, LINFLAG, DIRFLAG AS LONG

20  FBTITLE$=" ": FBDNAME$="00_INDEX.HTM"
  C$=COMMAND$: F$=""
  PRINT "FBF2HTM v2.0  (c) Ben Ritchey  Args=["+COMMAND$+"] "
40 CMDFIX:
  AA=INSTR(C$,"\")
  IF AA>0 THEN
    MID$(C$,AA,1)="/"
    GOTO CMDFIX
  END IF
100  ON ERROR GOTO START
120  OPEN "\FBF2HTM.INI" FOR INPUT AS #1
140  ON ERROR GOTO NOINI

GETINI1:
  LINE INPUT#1,A$
  IF EOF(1) THEN GOTO NOINI
  IF A$="" THEN GOTO GETINI1
  IF A$<>"" AND MID$(A$,1,1)="#" THEN GOTO GETINI1

  FBDNAME$=A$
'  FF=INSTR(FBDNAME$,".")  ' Parse LFNs
'  IF FF=0 THEN
'    IF LEN(FBDNAME$)>8 THEN
'      F$=FBDNAME$: FBDNAME$=MID$(F$,1,8)
'    END IF
'    GOTO GETINI2
'  END IF
'
'  IF LEN(FBDNAME$)>FF+3 THEN F$=FBDNAME$: FBDNAME$=MID$(F$,1,FF+3)
'  IF LEN(FBDNAME$)>12 THEN 
'    IF F$="" THEN F$=FBDNAME$
'    FBDNAME$=MID$(FBDNAME$,1,8)+MID$(FBDNAME$,FF)
'  END IF 

GETINI2:
  LINE INPUT#1,A$
  IF A$="" THEN GOTO GETINI2
  IF A$<>"" AND MID$(A$,1,1)="#" THEN GOTO GETINI2
  FBTITLE$=A$
NOINI:
  CLOSE #1

START:
1000  ON ERROR GOTO INTERROR
1020  OPEN "FILES.BBS" FOR INPUT AS #1
1040  OPEN FBDNAME$ FOR OUTPUT AS #2
    PRINT #2,"<HTML>"
    PRINT #2,"<HEAD>"
    PRINT #2,"<TITLE>"+FBTITLE$;
    IF LEN(C$)>2 THEN PRINT #2," - Area: "+C$;
    PRINT #2,"</TITLE>"
    PRINT #2,"</HEAD>"
    PRINT #2,"<A NAME="+CHR$(34)+"TOP"+CHR$(34)+"></A>"
    PRINT #2,"<BODY>"
    PRINT #2,"<CENTER>
    PRINT #2,"</CENTER>
    PRINT #2,"<TABLE border=1>"
    PRINT #2,"<CAPTION><H1><I><img src="+CHR$(34)+"/banner.png"+CHR$(34)+"></I></H1></CAPTION>"

    IF C$<>"" THEN
      PRINT #2,"<CAPTION><H2>";
      PRINT #2,"Directory of : ";
      PRINT #2,"<B>&nbsp;"+C$+"</B>";
      PRINT #2,"</H2></CAPTION>"
    END IF

    PRINT #2,"<TR><TH><FONT SIZE=4>File Name</TH>
    PRINT #2,"<TH><FONT SIZE=4>Modification_Date</TH>
    PRINT #2,"<TH><FONT SIZE=4>&nbsp;Size:Bytes</TH>
    PRINT #2,"<TH ALIGN=LEFT><FONT SIZE=4>&nbsp;Description</TH></FONT></TR>

    LINFLAG=2: DIRFLAG=0
SEARCH:
    IF EOF(1) THEN GOTO FINISHED
1060 LINE INPUT#1,A$

'print a$: z="[Enter]": gosub prompt  ' ******** debug

  IF A$="" THEN GOTO SEARCH
  IF MID$(A$,1)=SPACE$(LEN(A$)) THEN GOTO SEARCH
  IF MID$(A$,1,1)="-" THEN GOTO SEARCH
  IF MID$(A$,1,1)="\" THEN A=MID$(A,2)

  CA=ASC(MID$(A$,1,1)): IF CA<32 OR CA>126 THEN GOTO SEARCH
  IF INSTR(A$,"&")>0 THEN GOTO SEARCH
1080
  IF A$=FBDNAME$ THEN GOTO SEARCH  'OUTPUT FILE NAME

  IF INSTR(A$,".")=0 THEN GOTO NOTFILE  ' FORCE LOWER CASE IF FILE
'  FOR L=1 TO LEN(A$)
'    AA=ASC(MID$(A$,L,1))
'    IF AA>64 AND AA<91 THEN AA=AA+32: MID$(A$,L,1)=CHR$(AA)
'  NEXT L
    
NOTFILE:
'  IF A$="FILES.BBS" THEN GOTO SEARCH
  IF A$="FILES.FIX" THEN GOTO SEARCH
  IF A$="INDEX.HTM" THEN GOTO SEARCH
  IF A$="00_INDEX.HTM" THEN GOTO SEARCH
  IF A$="DESCRIPT.ION" THEN GOTO SEARCH

  IF MID$(A$,1,1)=" " THEN GOTO APPDESC

1100
  IF LINFLAG<2 THEN
    IF S$<>"" THEN
      FOR LC=1 TO LEN(S$)
        CA=ASC(MID$(S$,LC,1))
        IF CA<32 OR CA>126 THEN MID$(S$,LC,1)=" "
      NEXT LC
    END IF
1120
    PRINT #2,"<TD><B><FONT SIZE=3 FACE=Cambria,Georgia>"+S$+"</TD>";
    PRINT #2,"</FONT></B></TR>": S$="": LINFLAG=2
  END IF

  SL=INSTR(A$," ")
  IF SL>1 AND LEN(A$)>SL THEN
    FLNAME$=MID$(A$,1,SL-1): A$=MID$(A$,SL+1)
   ELSE
    FLNAME$=A$: A$=""
  END IF

'PRINT FLNAME$+" + "+A$  ' ******** Debug

  FOR NI=LEN(FLNAME$) TO 2 STEP -1
    IF MID$(FLNAME$,NI,1)=" " THEN FLNAME$=MID$(FLNAME$,1,NI-1)
  NEXT NI  

' DETECT LFN'S AND FLAG THEM
  IF LEN(FLNAME$)>12 AND INSTR(FLNAME$,"\")>0 THEN GOTO OKLFN
  IF LEN(FLNAME$)>12 AND (INSTR(FLNAME$," ")=0 OR INSTR(FLNAME$," ")>13) THEN
    PRINT #2,"<TR><TD ALIGN=CENTER><FONT SIZE=3 FACE=Helvetica,Georgia><B><A HREF="+CHR$(34);
    PRINT #2,FLNAME$+CHR$(34)+"> &raquo; </A></FONT></TD>"
    PRINT #2,"<TD ALIGN=LEFT><B>&nbsp;{ LFN } &nbsp;&nbsp;&nbsp;&raquo;</B></TD>";
    PRINT #2,"<TD ALIGN=RIGHT>?</TD>"
    A$="<A HREF="+CHR$(34)+FLNAME$+CHR$(34)+">"+FLNAME$
    GOTO APPDESC
  END IF

OKLFN:
  PRINT #2,"<TR><TD><FONT SIZE=3 FACE=Helvetica,Georgia><B><A HREF="+CHR$(34);
  PRINT #2,FLNAME$+CHR$(34)+">"+FLNAME$+"</A></FONT></TD>"
  OPEN "\$DIR$.BAT" FOR OUTPUT AS #4
  PRINT #4,"@del \$DIR$"
  PRINT #4,"@cmd /c DIR /X "+FLNAME$+" >\$DIR$"
  CLOSE #4
  SHELL "\$DIR$.BAT"
  OPEN "\$DIR$" FOR INPUT AS #3
  DREC$="-": DTE$="<B>&raquo; NOT found! &laquo;</B>"
FINDIT:
  FOR FL=1 TO 6
  IF EOF(3) THEN 
    LET FL=6
   ELSE
    LINE INPUT#3,D$
  END IF
  NEXT FL
  CLOSE #3
'DEBUG: PRINT D$
  IF D$="" GOTO GO4IT

  IF MID$(D$,1)=SPACE$(LEN(D$)) THEN GOTO GO4IT

  FLNME$=TRIM$(MID$(D$,40))

  FLNME$=TRIM$(FLNME$)
  FLNAME$=TRIM$(FLNAME$)
'print FLNME$,FLNAME$ ' ******** Debug
  IF MID$(FLNME$,1,LEN(FLNAME$))=FLNAME$ THEN
    DTE$=MID$(D$,1,20)
    DREC$=MID$(D$,21,19) ':DREC$=MID$(SPACE$(10),1,10-LEN(DREC$))+DREC$
  END IF

  IF MID$(D$,25,5)="<DIR>" THEN
    DIRFLAG=1
    DTE$=MID$(D$,1,20)
    DREC$="<img src="+CHR$(34)+"/icons/dir.png"+CHR$(34)+">"
  END IF

GO4IT:

' LINE UP TIME AT END OF DATE/TIME

  IF MID$(DTE$,13,1)=" " THEN DTE$=MID$(DTE$,1,12)+"&nbsp;"+MID$(DTE$,14)

  PRINT #2,"<TD ALIGN=LEFT>"+DTE$+"</TD>";

  IF DIRFLAG=0 AND DREC$<>"-" THEN
    PRINT #2,"<TD ALIGN=RIGHT>";
    PRINT #2,DREC$;
    PRINT #2,"</TD>"
   ELSE
    IF DIRFLAG=1 THEN
      PRINT #2,"<TD ALIGN=LEFT>"+DREC$+"</TD>"
     ELSE
      PRINT #2,"<TD ALIGN=RIGHT>"+DREC$+"</TD>"
    END IF
  END IF

  LINFLAG=1
'  Z$=FLNAME$: GOSUB MESSAGE

APPDESC:

  EL=LEN(A$)-1                  ' TRUNC LEADING SPACES
  FOR SL=1 TO EL
    IF MID$(A$,1,1)=" " THEN
      A$=MID$(A$,2)
     ELSE
      SL=EL
    END IF
  NEXT SL

  EL=LEN(A$)                    ' TRUNC TRAILING SPACES
  FOR SL=EL TO 2 STEP -1
    IF MID$(A$,SL,1)=" " THEN
      A$=MID$(A$,1,LEN(A$)-1)
     ELSE
      SL=2
    END IF
  NEXT SL

  IF LEN(A$)>8 THEN IF A$=STRING$(LEN(A$),MID$(A$,1,1)) THEN A$=" "

  S$=S$+" "+A$
  LINFLAG=0: DIRFLAG=0
  GOTO SEARCH

  ERROR 123: REM Error Trap {Next line should NEVER be executed ...}
  GOTO FINISHED

5000 REM
PROMPT:
  COLOR 7: PRINT Z$;: COLOR 15: INPUT A$
  COLOR 3: RETURN

MESSAGE:
  PRINT Z$: RETURN

INTERROR:
  AB=ERL: AA=ERRCLEAR: AC$=ERROR$(AA)
  IF AB=1020 AND AA=53 THEN
    OPEN "\$DIR$.BAT" FOR OUTPUT AS #4
    PRINT #4,"@cmd /c DIR /B *.* >FILES.BBS"
    CLOSE #4
    SHELL "\$DIR$.BAT"
    RESUME 1020
  END IF

10000 PRINT
  BEEP
  COLOR 14
  PRINT "  Internal Error: Line";AB;ERL$;"  Code";AA;" = ";AC$
  PRINT "  Press any key ...";
  A="": WHILE A="": A=INKEY$: WEND
'  ON ERROR GOTO 0 ' Run-time use!
  RESUME FINISHED

' *** Debug
  BEEP
  PRINT "Ok": A$="": WHILE A$="": A$=INKEY$: WEND
' *** Debug

FINISHED:
50000 'COLOR 7: PRINT
'  Z$ = "": AA = 0
  PRINT #2,"<TD><B><FONT SIZE=3 FACE=Cambria,Georgia>"+S$+"</TD></FONT></B></TR>"
rem  PRINT #2,""
  PRINT #2,"</FONT></TABLE><BR><P><A HREF="+CHR$(34)+"#TOP";
  PRINT #2,CHR$(34)+">Back to TOP</A>"
  PRINT #2,"<BR><P><LEFT>"
  PRINT #2,"<FONT FACE=Cambria,Georgia SIZE=3>Generated by &nbsp;";
  PRINT #2,"FBF2HTM v1.0&nbsp; &copy; 2015 Ben Ritchey with "
  PRINT #2,"&nbsp;<A HREF="+CHR$(34)+"http://cmech.dynip.com"+CHR$(34)+">"
  PRINT #2,"The Positronium Repository</A> &nbsp;as of &nbsp;";
  PRINT #2,DATE$+" "+TIME$+"</FONT><BR></LEFT>"
  PRINT #2,"<HR><HR><BR><P></BODY>"
  PRINT #2,"</HTML>"

50100  CLOSE
'50200  KILL "\$DIR$.BAT"
'50300  KILL "\$DIR$"

  A$="MOVE "+FBDNAME$+" "+F$
  IF F$<>"" THEN
    SHELL A$+" >NUL"
  END IF
JUMPOUT:
'Z$="SYSTEM Exit next...ENTER": GOSUB PROMPT  ' ******** Debug

REM Month Table Data
  DATA January, February, March, April, May, June
  DATA July, August, September, October, November, December
  DATA Jan, Feb, Mar, Apr, May, Jun, Jul, Aug, Sep, Oct, Nov, Dec
REM *** End of fbd2htm.Bas ***

END FUNCTION

